Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/Plugin.cs.frame
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/Plugin.cs.frame	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Collections/3.3/Plugin.cs.frame	(revision 10479)
@@ -29,4 +29,5 @@
   [PluginFile("HeuristicLab.Collections-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
   public class HeuristicLabCollectionsPlugin : PluginBase {
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/ArrayExtensions.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/ArrayExtensions.cs	(revision 10479)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/ArrayExtensions.cs	(revision 10479)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Common {
+  public static class ArrayExtensions {
+    public static void StableSort<T>(this T[] values) {
+      values.StableSort(0, values.Length);
+    }
+
+    public static void StableSort<T>(this T[] values, int index, int count) {
+      var sortedArray = values.Skip(index).Take(count).OrderBy(x => x).ToArray();
+      Array.ConstrainedCopy(sortedArray, 0, values, index, count);
+    }
+
+    public static void StableSort<T>(this T[] values, IComparer<T> comparer) {
+      values.StableSort(0, values.Length, comparer);
+    }
+
+    public static void StableSort<T>(this T[] values, int index, int count, IComparer<T> comparer) {
+      var sortedArray = values.Skip(index).Take(count).OrderBy(x => x, comparer).ToArray();
+      Array.ConstrainedCopy(sortedArray, 0, values, index, count);
+    }
+
+    public static void StableSort<T>(this T[] values, Comparison<T> comparison) {
+      values.StableSort(0, values.Length, comparison);
+    }
+
+    public static void StableSort<T>(this T[] values, int index, int count, Comparison<T> comparison) {
+      var sortedArray = values.Skip(index).Take(count).OrderBy(x => x, new StableSortComparer<T>(comparison)).ToArray();
+      Array.ConstrainedCopy(sortedArray, 0, values, index, count);
+    }
+
+    public class StableSortComparer<T> : IComparer<T> {
+      public StableSortComparer(Comparison<T> comparison) {
+        this.comparison = comparison;
+      }
+      public int Compare(T x, T y) {
+        return comparison(x, y);
+      }
+      private readonly Comparison<T> comparison;
+    }
+  }
+}
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/HeuristicLab.Common-3.3.csproj
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/HeuristicLab.Common-3.3.csproj	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/HeuristicLab.Common-3.3.csproj	(revision 10479)
@@ -124,4 +124,6 @@
     <Compile Include="Content\IStorableContent.cs" />
     <Compile Include="Constants.cs" />
+    <Compile Include="ArrayExtensions.cs" />
+    <Compile Include="ListExtensions.cs" />
     <Compile Include="Point2D.cs" />
     <Compile Include="EnumerableExtensions.cs" />
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/ListExtensions.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/ListExtensions.cs	(revision 10479)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Common/3.3/ListExtensions.cs	(revision 10479)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Common {
+  public static class ListExtensions {
+    public static void StableSort<T>(this List<T> values) {
+      values.StableSort(0, values.Count);
+    }
+
+    public static void StableSort<T>(this List<T> values, int index, int count) {
+      var orderedList = values.Skip(index).Take(count).OrderBy(x => x);
+      int i = index;
+      foreach (var e in orderedList)
+        values[i++] = e;
+    }
+
+    public static void StableSort<T>(this List<T> values, IComparer<T> comparer) {
+      values.StableSort(0, values.Count, comparer);
+    }
+
+    public static void StableSort<T>(this List<T> values, int index, int count, IComparer<T> comparer) {
+      var orderedList = values.OrderBy(x => x, comparer);
+      int i = 0;
+      foreach (var e in orderedList)
+        values[i++] = e;
+    }
+
+    public static void StableSort<T>(this List<T> values, Comparison<T> comparison) {
+      values.StableSort(0, values.Count, comparison);
+    }
+
+    public static void StableSort<T>(this List<T> values, int index, int count, Comparison<T> comparison) {
+      var orderedList = values.OrderBy(x => x, new StableSortComparer<T>(comparison));
+      int i = 0;
+      foreach (var e in orderedList)
+        values[i++] = e;
+    }
+
+    public class StableSortComparer<T> : IComparer<T> {
+      public StableSortComparer(Comparison<T> comparison) {
+        this.comparison = comparison;
+      }
+      public int Compare(T x, T y) {
+        return comparison(x, y);
+      }
+      private readonly Comparison<T> comparison;
+    }
+  }
+}
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 10479)
@@ -150,4 +150,5 @@
     <Compile Include="Interfaces\ICheckedMultiOperator.cs" />
     <Compile Include="Interfaces\IConstrainedValueParameter.cs" />
+    <Compile Include="Interfaces\IInstrumentedOperator.cs" />
     <Compile Include="Interfaces\IMultiOperator.cs" />
     <Compile Include="Interfaces\IFixedValueParameter.cs" />
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Core/3.3/Interfaces/IInstrumentedOperator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Core/3.3/Interfaces/IInstrumentedOperator.cs	(revision 10479)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Core/3.3/Interfaces/IInstrumentedOperator.cs	(revision 10479)
@@ -0,0 +1,32 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System.Collections;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Core {
+  public interface IInstrumentedOperator : IOperator {
+    IEnumerable<IOperator> BeforeExecutionOperators { get; }
+    IEnumerable<IOperator> AfterExecutionOperators { get; }
+  }
+}
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Data/3.3/PercentValue.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Data/3.3/PercentValue.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Data/3.3/PercentValue.cs	(revision 10479)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,11 +29,35 @@
   [StorableClass]
   public class PercentValue : DoubleValue {
+    [Storable(DefaultValue = false)]
+    private bool restrictToUnitInterval = false;
+    public bool RestrictToUnitInterval {
+      get { return restrictToUnitInterval; }
+    }
+
+    public override double Value {
+      get { return base.Value; }
+      set {
+        if (restrictToUnitInterval && (value < 0 || value > 1))
+          throw new ArgumentException("Value must lie in the interval [0,1].");
+        base.Value = value;
+      }
+    }
+
     [StorableConstructor]
     protected PercentValue(bool deserializing) : base(deserializing) { }
     protected PercentValue(PercentValue original, Cloner cloner)
       : base(original, cloner) {
+      restrictToUnitInterval = original.restrictToUnitInterval;
     }
     public PercentValue() : base() { }
     public PercentValue(double value) : base(value) { }
+
+    public PercentValue(double value, bool restrictToUnitInterval)
+      : base() {
+      this.restrictToUnitInterval = restrictToUnitInterval;
+      if (restrictToUnitInterval && (value < 0 || value > 1))
+        throw new ArgumentException("Value must lie in the interval [0,1].");
+      this.value = value;
+    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -46,6 +71,15 @@
     protected override bool Validate(string value, out string errorMessage) {
       value = value.Replace("%", " ");
-      return base.Validate(value, out errorMessage);
+      bool valid = base.Validate(value, out errorMessage);
+      if (!restrictToUnitInterval || !valid) return valid;
+
+      double val = double.Parse(value);
+      if (val < 0 || val > 1) {
+        errorMessage = "Value must lie in the interval [0,1].";
+        return false;
+      }
+      return true;
     }
+
     protected override string GetValue() {
       return Value.ToString("#0.#################### %");  // percent format
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCreator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCreator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCreator.cs	(revision 10479)
@@ -34,5 +34,5 @@
   [Item("BinaryVectorCreator", "A base class for operators creating bool-valued vectors.")]
   [StorableClass]
-  public abstract class BinaryVectorCreator : SingleSuccessorOperator, IBinaryVectorCreator, IStochasticOperator {
+  public abstract class BinaryVectorCreator : InstrumentedOperator, IBinaryVectorCreator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -58,7 +58,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       BinaryVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCrossover.cs	(revision 10479)
@@ -33,5 +33,5 @@
   [Item("BinaryVectorCrossover", "A base class for operators that perform a crossover of bool-valued vectors.")]
   [StorableClass]
-  public abstract class BinaryVectorCrossover : SingleSuccessorOperator, IBinaryVectorCrossover, IStochasticOperator {
+  public abstract class BinaryVectorCrossover : InstrumentedOperator, IBinaryVectorCrossover, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -59,7 +59,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorManipulator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorManipulator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorManipulator.cs	(revision 10479)
@@ -33,5 +33,5 @@
   [Item("BinaryVectorManipulator", "A base class for operators that manipulate bool-valued vectors.")]
   [StorableClass]
-  public abstract class BinaryVectorManipulator : SingleSuccessorOperator, IBinaryVectorManipulator, IStochasticOperator {
+  public abstract class BinaryVectorManipulator : InstrumentedOperator, IBinaryVectorManipulator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -53,7 +53,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       Manipulate(RandomParameter.ActualValue, BinaryVectorParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs	(revision 10479)
@@ -64,4 +64,6 @@
           Operators.Add((IBinaryVectorCrossover)Activator.CreateInstance(type), true);
       }
+
+      SelectedOperatorParameter.ActualName = "SelectedCrossoverOperator";
     }
 
@@ -90,7 +92,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one binary vector crossover to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs	(revision 10479)
@@ -70,4 +70,6 @@
           Operators.Add((IIntegerVectorCrossover)Activator.CreateInstance(type), true);
       }
+
+      SelectedOperatorParameter.ActualName = "SelectedCrossoverOperator";
     }
 
@@ -99,7 +101,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one integer vector crossover to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCreator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCreator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCreator.cs	(revision 10479)
@@ -34,5 +34,5 @@
   [Item("IntegerVectorCreator", "A base class for operators creating int-valued vectors.")]
   [StorableClass]
-  public abstract class IntegerVectorCreator : SingleSuccessorOperator, IIntegerVectorCreator, IStochasticOperator {
+  public abstract class IntegerVectorCreator : InstrumentedOperator, IIntegerVectorCreator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -79,7 +79,7 @@
     #endregion
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       IntegerVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue, BoundsParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 10479)
@@ -58,7 +58,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 10479)
@@ -52,7 +52,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       Manipulate(RandomParameter.ActualValue, IntegerVectorParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorOperator.cs	(revision 10479)
@@ -29,5 +29,5 @@
   [Item("IntegerVectorOperator", "Base class for integer vectoro operators.")]
   [StorableClass]
-  public abstract class IntegerVectorOperator : SingleSuccessorOperator, IIntegerVectorOperator {
+  public abstract class IntegerVectorOperator : InstrumentedOperator, IIntegerVectorOperator {
 
     [StorableConstructor]
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Creators/RandomPermutationCreator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Creators/RandomPermutationCreator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Creators/RandomPermutationCreator.cs	(revision 10479)
@@ -34,5 +34,5 @@
   [Item("RandomPermutationCreator", "An operator which creates a new random permutation of integer values.")]
   [StorableClass]
-  public sealed class RandomPermutationCreator : SingleSuccessorOperator, IPermutationCreator, IStochasticOperator {
+  public sealed class RandomPermutationCreator : InstrumentedOperator, IPermutationCreator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -72,7 +72,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       PermutationParameter.ActualValue = new Permutation(PermutationType, LengthParameter.ActualValue.Value, RandomParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs	(revision 10479)
@@ -64,4 +64,6 @@
           Operators.Add((IPermutationCrossover)Activator.CreateInstance(type), true);
       }
+
+      SelectedOperatorParameter.ActualName = "SelectedCrossoverOperator";
     }
 
@@ -90,7 +92,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one permutation crossover to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs	(revision 10479)
@@ -57,4 +57,6 @@
           Operators.Add((IPermutationManipulator)Activator.CreateInstance(type), true);
       }
+
+      SelectedOperatorParameter.ActualName = "SelectedManipulationOperator";
     }
 
@@ -82,7 +84,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one permutation manipulator to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationCrossover.cs	(revision 10479)
@@ -33,5 +33,5 @@
   [Item("PermutationCrossover", "A base class for permutation crossover operators.")]
   [StorableClass]
-  public abstract class PermutationCrossover : SingleSuccessorOperator, IPermutationCrossover, IStochasticOperator {
+  public abstract class PermutationCrossover : InstrumentedOperator, IPermutationCrossover, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -60,7 +60,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationManipulator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationManipulator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationManipulator.cs	(revision 10479)
@@ -33,5 +33,5 @@
   [Item("PermutationManipulator", "A base class for permutation manipulation operators.")]
   [StorableClass]
-  public abstract class PermutationManipulator : SingleSuccessorOperator, IPermutationManipulator, IStochasticOperator {
+  public abstract class PermutationManipulator : InstrumentedOperator, IPermutationManipulator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -54,7 +54,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       Manipulate(RandomParameter.ActualValue, PermutationParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/Crossovers/MultiRealVectorCrossover.cs	(revision 10479)
@@ -70,4 +70,6 @@
           Operators.Add((IRealVectorCrossover)Activator.CreateInstance(type), true);
       }
+
+      SelectedOperatorParameter.ActualName = "SelectedCrossoverOperator";
     }
 
@@ -97,7 +99,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one real vector crossover to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/Manipulators/MultiRealVectorManipulator.cs	(revision 10479)
@@ -62,4 +62,6 @@
       Operators.Add(new PolynomialOnePositionManipulator());
       Operators.Add(new UniformOnePositionManipulator());
+
+      SelectedOperatorParameter.ActualName = "SelectedManipulationOperator";
     }
 
@@ -88,7 +90,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one real vector manipulator to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCreator.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCreator.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCreator.cs	(revision 10479)
@@ -34,5 +34,5 @@
   [Item("RealVectorCreator", "A base class for operators creating real-valued vectors.")]
   [StorableClass]
-  public abstract class RealVectorCreator : SingleSuccessorOperator, IRealVectorCreator, IStochasticOperator {
+  public abstract class RealVectorCreator : InstrumentedOperator, IRealVectorCreator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -63,7 +63,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       RealVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue, BoundsParameter.ActualValue);
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCrossover.cs
===================================================================
--- branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCrossover.cs	(revision 10473)
+++ branches/SpectralKernelForGaussianProcesses/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVectorCrossover.cs	(revision 10479)
@@ -35,5 +35,5 @@
   [Item("RealVectorCrossover", "A base class for operators that perform a crossover of real-valued vectors.")]
   [StorableClass]
-  public abstract class RealVectorCrossover : SingleSuccessorOperator, IRealVectorCrossover, IStochasticOperator {
+  public abstract class RealVectorCrossover : InstrumentedOperator, IRealVectorCrossover, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -96,9 +96,9 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation InstrumentedApply() {
       RealVector result = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
       ChildParameter.ActualValue = result;
 
-      IOperation successor = base.Apply();
+      IOperation successor = base.InstrumentedApply();
       if (BoundsChecker != null) {
         IOperation checkerOperation = ExecutionContext.CreateChildOperation(BoundsChecker);
